Bug 995025 - Review Request: rnv - RelaxNG Compact syntax validator in C
Review Request: rnv - RelaxNG Compact syntax validator in C
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Stanislav Ochotnicky
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-08 08:27 EDT by Michael Simacek
Modified: 2013-08-31 19:57 EDT (History)
3 users (show)

See Also:
Fixed In Version: rnv-1.7.11-5.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-31 19:57:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sochotni: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michael Simacek 2013-08-08 08:27:13 EDT
Spec URL: http://msimacek.fedorapeople.org/rnv.spec
SRPM URL: http://msimacek.fedorapeople.org/rnv-1.7.11-1.fc19.src.rpm
Description: RNV uses Relax NG compact syntax schemas to check if a give XML file is valid in respect to the language defined by the Relax  NG  schema.  RNV
uses Expat for XML parsing.
Fedora Account System Username: msimacek
Comment 1 Stanislav Ochotnicky 2013-08-08 08:40:50 EDT
I'll do the review and sponsorship process...
Comment 2 Stanislav Ochotnicky 2013-08-08 09:08:21 EDT
Package looks OK for the most part. Licensing is good (there are a few files under different licenses but they don't get into binary RPM so BSD is correct). 

Perhaps the only suggestion I have now before starting full-scale review: It might be nice to package tools/*rnc as samples and tools/*vim as vim plugin.

Vim plugin would require patching as it uses /usr/local directory for default configuration lookup and wouldn't work since we have no default configuration shipped. On the other hand shipping and installing that arx.conf into /etc might make sense. And then let vim plugin use that (it would be possible to override with a variable though...so maybe something that could be added and provided upstream)
Comment 3 Christopher Meng 2013-08-08 22:08:18 EDT
Suggestion:

1. %{_mandir}/man1/rnv.1.gz

You'd better change to:

%{_mandir}/man1/rnv.1*

Easy, but it will help RPM auto generate gzipped manpages.

2. valid in respect to the language defined by the Relax  NG  schema.  RNV

Spaces too many, suggestion:

valid in respect to the language defined by the Relax NG schema. RNV
Comment 4 Michael Simacek 2013-08-14 09:19:09 EDT
I patched rnv, arx and build to install arx.conf into /etc/rnv and modified conf lookup so it can find it. I created subpackages for python and perl examples and for the vim plugin. I also created man pages for previously undocumented executables. I added dependency to docbook schemas, because arx is configured to use it, but doesn't ship it.
SPEC URL: http://msimacek.fedorapeople.org/rnv.spec
SRPM URL: http://msimacek.fedorapeople.org/rnv-1.7.11-2.fc19.src.rpm
Comment 5 Christopher Meng 2013-08-15 04:56:48 EDT
OK.

Are these .1 files sent to upstream already?

and one "question"

%package vimplugin

do we need to change to 

%package vim?(I'm sorry I don't know other vim plugins' situation in Fedora)
Comment 6 Michael Schwendt 2013-08-15 06:21:40 EDT
IMO, it should be vim-rnv following the %parent-%child naming guidelines for add-on packages

  https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Addon_Packages_.28General.29

which we are supposed to put to good use. Also notice this related thread I've opened recently: https://lists.fedoraproject.org/pipermail/packaging/2013-August/009422.html
Comment 7 Michael Simacek 2013-08-15 09:14:45 EDT
Thank you for the feedback.
I renamed the vimplugin subackage to vim-rnv.
And yes, I already sent those manpages to upstream.

SPEC URL:http://msimacek.fedorapeople.org/rnv.spec
SRPM URL:http://msimacek.fedorapeople.org/rnv-1.7.11-3.fc19.src.rpm
Comment 8 Stanislav Ochotnicky 2013-08-16 07:45:29 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


First a list of issues I've noticed:
  - vim-rnv references file /usr/local/share/rng-c/arx.conf
  - vim-rnv should require main package
  - I would not put the examples in separate subpackage since they are pretty
    small. Just mark them as %doc IMO (but it's up to you). if you leave them in
    subpackage then it has to require main package (due to dir ownership and rnv
    usage). 
  - It's usually better idea to patch .am file and re-run autotools than to
    patch generated files
  - it's customary to group package descriptions/definitions before %prep
    section at the top and files sections just before changelog. There's no
    strict rule about this though



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rnv-
     examples , vim-rnv

     vim-rnv should definitely require main package

[!]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
[!]: License file installed when any subpackage combination is installed.

if examples stayed as separate package without requiring main package they would
need to include COPYING file as well but since they would have to require main
package which includes this file this is not needed (just note for future)

[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 61440 bytes in 5 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rnv-1.7.11-3.fc19.x86_64.rpm
          rnv-examples-1.7.11-3.fc19.noarch.rpm
          vim-rnv-1.7.11-3.fc19.noarch.rpm
rnv.x86_64: W: spelling-error Summary(en_US) validator -> lavatorial
rnv.x86_64: W: spelling-error %description -l en_US schemas -> schema, sachems, schemes
vim-rnv.noarch: W: spelling-error %description -l en_US schemas -> schema, sachems, schemes
vim-rnv.noarch: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint vim-rnv rnv rnv-examples
vim-rnv.noarch: W: spelling-error %description -l en_US schemas -> schema, sachems, schemes
vim-rnv.noarch: W: no-documentation
rnv.x86_64: W: spelling-error Summary(en_US) validator -> lavatorial
rnv.x86_64: W: spelling-error %description -l en_US schemas -> schema, sachems, schemes
3 packages and 0 specfiles checked; 0 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
vim-rnv (rpmlib, GLIBC filtered):
    vim-common

rnv (rpmlib, GLIBC filtered):
    config(rnv)
    docbook5-schemas
    libc.so.6()(64bit)
    libexpat.so.1()(64bit)
    rtld(GNU_HASH)

rnv-examples (rpmlib, GLIBC filtered):



Provides
--------
vim-rnv:
    vim-rnv

rnv:
    config(rnv)
    rnv
    rnv(x86-64)

rnv-examples:
    rnv-examples



Source checksums
----------------
http://downloads.sourceforge.net/project/rnv/Sources/1.7.11/rnv-1.7.11.tar.xz :
  CHECKSUM(SHA256) this package     : 4ab920f1e4d60841bdc17dbed72ae735bf825af8a9d9eda99165a13be7cc9de6
  CHECKSUM(SHA256) upstream package : 4ab920f1e4d60841bdc17dbed72ae735bf825af8a9d9eda99165a13be7cc9de6


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-19-x86_64
Command line :/bin/fedora-review -b 995025
Comment 9 Michael Simacek 2013-08-16 09:25:07 EDT
Thank you,
I corrected the .vim file, removed the examples subpackage and use autoreconf instead of patching Makefile.in.

SPEC: http://msimacek.fedorapeople.org/rnv.spec
SRPM: http://msimacek.fedorapeople.org/rnv-1.7.11-5.fc19.src.rpm
Comment 10 Stanislav Ochotnicky 2013-08-16 10:02:44 EDT
Package looks good to me now-> APPROVED

I'll sponsor you to packager group and you should be able to start building by the time you get repos.
Comment 11 Michael Simacek 2013-08-16 10:18:37 EDT
New Package SCM Request
=======================
Package Name: rnv
Short Description: RNV uses Relax NG compact syntax schemas to check if a given XML file is valid in respect to the language defined by the Relax NG schema
Owners: msimacek
Branches: f19
InitialCC:
Comment 12 Gwyn Ciesla 2013-08-16 10:57:45 EDT
Git done (by process-git-requests).
Comment 13 Fedora Update System 2013-08-19 04:33:03 EDT
rnv-1.7.11-5.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/rnv-1.7.11-5.fc19
Comment 14 Fedora Update System 2013-08-19 17:22:26 EDT
rnv-1.7.11-5.fc19 has been pushed to the Fedora 19 testing repository.
Comment 15 Fedora Update System 2013-08-31 19:57:39 EDT
rnv-1.7.11-5.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.